/* 
 * Copyright (C) 2013 Luca Zanetti. All rights reserved.
 *
 * This file may be used under the terms of the GNU General Public License
 * versions 3.0 as published by the Free Software Foundation and
 * appearing in the COPYING file included in the packaging of this file.
 *
 * This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
 *  WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
*/

#include <stdio.h>
#include <stdlib.h>
#include "list.h"

List create_list(int n) {
	int i;
	List head = NULL;
	item *new;
	for (i=n-1; i>=0; i--) {
		new = (item *) malloc(sizeof(item));
		new->val = i;
		new->next = head;
		head = new;
	}
	return head;
}

/* add an item with value val at the head of the list */
List add(List head, int val) {
	List new = malloc(sizeof(item));
	new->val = val;
	new->next = head;
	return new;
}

/* return the value contained in item n of the list */
int val(List head, int n) {
	if (n == 0) return head->val;
	head = head->next;
	int i;
	for (i=1; i<n; i++) {
		head = head->next;
	}
	return head->val;
}

/* destroy the list */
void destroy(List head) {
	item *next, *curr;
	curr = head;
	while (curr) {
		next = curr->next;
		free(curr);
		curr = next;
	}
}
